'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderRoute = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

var _BundleLoader = require('./BundleLoader');

var _BundleLoader2 = _interopRequireDefault(_BundleLoader);

var _utils = require('./../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var renderRoute = exports.renderRoute = function renderRoute(_ref) {
  var _class, _temp, _initialiseProps;

  var component = _ref.component,
      path = _ref.path,
      serverProps = _ref.serverProps,
      meta = _ref.meta;
  return _temp = _class = function (_Component) {
    _inherits(Wrapper, _Component);

    function Wrapper(props, context) {
      _classCallCheck(this, Wrapper);

      var _this = _possibleConstructorReturn(this, (Wrapper.__proto__ || Object.getPrototypeOf(Wrapper)).call(this, props));

      _initialiseProps.call(_this);

      var pathname = context.router.route.location.pathname;


      _this.state = {
        pathname: pathname,
        data: serverProps[pathname],
        getInitialProps: (0, _utils.requiresPrefetch)(component),
        urlParams: (0, _utils.getParamsFromUrl)(path, pathname)
      };
      return _this;
    }

    _createClass(Wrapper, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        this.fetchClientData().then(this.updateMetaData);
      }

      //  Update meta with side-effects

    }, {
      key: 'render',
      value: function render() {
        var _state = this.state,
            data = _state.data,
            getInitialProps = _state.getInitialProps;

        var WrappedRoute = component;

        if (!data && getInitialProps) {
          return null;
        }

        return _react2.default.createElement(WrappedRoute, { data: data });
      }
    }]);

    return Wrapper;
  }(_react.Component), _class.contextTypes = { router: _propTypes2.default.any }, _class.defaultProps = {}, _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this.fetchClientData = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
      var _state2, getInitialProps, pathname, urlParams, data, clientData;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _state2 = _this2.state, getInitialProps = _state2.getInitialProps, pathname = _state2.pathname, urlParams = _state2.urlParams;
              data = serverProps[pathname];

              if (!(!data && getInitialProps)) {
                _context.next = 7;
                break;
              }

              _context.next = 5;
              return (0, _utils.fetchInitialProps)(component.getInitialProps, urlParams);

            case 5:
              clientData = _context.sent;

              _this2.setState({ data: clientData });

            case 7:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this2);
    }));

    this.updateMetaData = function () {
      var urlParams = _this2.state.urlParams;

      var _getMetaData = (0, _utils.getMetaData)({ meta: meta }, urlParams),
          title = _getMetaData.title,
          description = _getMetaData.description;

      var metaDescription = document.querySelectorAll('meta[name="description"]')[0];

      document.title = title;
      metaDescription.setAttribute('value', description);
    };
  }, _temp;
};

exports.default = function (props) {
  var component = props.component,
      bundle = props.bundle,
      rest = _objectWithoutProperties(props, ['component', 'bundle']);

  //  If 'bundle' is defined in the current
  //  route, then we should attempt to lazy load it


  return typeof component !== 'undefined' ? _react2.default.createElement(_reactRouterDom.Route, _extends({}, props, {
    component: renderRoute(props)
  })) : _react2.default.createElement(_reactRouterDom.Route, _extends({}, rest, {
    render: function render() {
      return _react2.default.createElement(_BundleLoader2.default, _extends({}, rest, { bundle: bundle }));
    }
  }));
};