'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var resolveHtml = function resolveHtml(fileLoader, indexPath) {
  return new Promise(function (resolve, reject) {
    return fileLoader.readFile(indexPath, function (err, fileContents) {
      var templateString = void 0;
      try {
        templateString = fileContents.toString();
      } catch (error) {
        reject('Compilation in progress... Hold tight!');
      } finally {
        resolve(templateString);
      }
    });
  });
};

exports.default = function (app, config) {
  return function () {
    var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(req, res, next) {
      var _app, isDevEnvironment, indexPath, fileLoader;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _app = app;
              isDevEnvironment = config.isDevEnvironment;
              indexPath = isDevEnvironment ? _path2.default.resolve(process.cwd(), 'public/index.html') : _path2.default.resolve(process.cwd(), './public/index.html');
              fileLoader = isDevEnvironment ? app.locals.compiler.outputFileSystem : _fs2.default;

              if (!(app.locals && app.locals.html)) {
                _context.next = 8;
                break;
              }

              _context.t0 = app.locals.html;
              _context.next = 11;
              break;

            case 8:
              _context.next = 10;
              return resolveHtml(fileLoader, indexPath);

            case 10:
              _context.t0 = _context.sent;

            case 11:
              _app.locals.html = _context.t0;


              res.set('content-type', 'text/html');
              next();

            case 14:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function (_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();
};