'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpackDevMiddleware = require('webpack-dev-middleware');

var _webpackDevMiddleware2 = _interopRequireDefault(_webpackDevMiddleware);

var _webpackHotMiddleware = require('webpack-hot-middleware');

var _webpackHotMiddleware2 = _interopRequireDefault(_webpackHotMiddleware);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _webpack3 = require('./webpack/webpack.config');

var _webpack4 = _interopRequireDefault(_webpack3);

var _middleware = require('./middleware');

var _middleware2 = _interopRequireDefault(_middleware);

var _hooks = require('./hooks');

var _hooks2 = _interopRequireDefault(_hooks);

var _defaultConfig = require('./webpack/defaultConfig');

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

//  Run hooks before
//  starting application
(0, _hooks2.default)();

var createServer = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(config, diagnosticRoutes, callback) {
    var appName, port, _config$publicPath, publicPath, _config$distOutput, distOutput, isDevEnvironment, app, webpackConfig;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            appName = config.appName, port = config.port, _config$publicPath = config.publicPath, publicPath = _config$publicPath === undefined ? _defaultConfig2.default.publicPath : _config$publicPath, _config$distOutput = config.distOutput, distOutput = _config$distOutput === undefined ? _defaultConfig2.default.distOutput : _config$distOutput, isDevEnvironment = config.isDevEnvironment;
            app = (0, _express2.default)();

            //  Let express.static handle all static assets

            if (!isDevEnvironment) {
              app.use(publicPath, _express2.default.static(_path2.default.join(process.cwd(), distOutput, publicPath)));
            }

            //  Inject webpack-dev-middleware and hot-reloading
            if (isDevEnvironment) {
              webpackConfig = (0, _webpack4.default)(config);

              app.locals.compiler = (0, _webpack2.default)(webpackConfig);
              app.use(publicPath, (0, _webpackDevMiddleware2.default)(app.locals.compiler));
              app.use((0, _webpackHotMiddleware2.default)(app.locals.compiler));
            }

            //  Apply diagnostic routes (if they exist)
            Object.keys(diagnosticRoutes).forEach(function (key) {
              return app.get(key, diagnosticRoutes[key]);
            });

            //  Apply composed middleware to each request
            app.use((0, _middleware2.default)(app, config), function (req, res) {
              return res.send(app.locals.output);
            });

            //  Start on port
            app.listen(port || 3000, function () {
              if (callback && typeof callback === 'function') {
                callback('                  \nRCA-Juno: starting ' + appName + '\nhttp://localhost:' + (port || 3000) + '\nEnvironment: ' + _chalk2.default.blue(isDevEnvironment ? 'development' : 'production') + '\n');
              }
            });

            return _context.abrupt('return', app);

          case 8:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function createServer(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = createServer;