'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _rimraf = require('rimraf');

var _rimraf2 = _interopRequireDefault(_rimraf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var handleError = function handleError(err) {
  throw new Error(err);
};

var createOutputFolder = function createOutputFolder() {
  var outputPath = _path2.default.resolve(process.cwd(), './public');

  return new Promise(function (resolve) {
    if (!_fs2.default.existsSync(outputPath)) {
      _fs2.default.mkdir(outputPath, function (err) {
        if (err) handleError(err);
        resolve();
      });
    } else {
      (0, _rimraf2.default)(outputPath, function (err) {
        if (err) handleError(err);
        resolve(createOutputFolder(outputPath));
      });
    }
  });
};

exports.default = createOutputFolder;