//  @flow
import React, { Component } from 'react';
import PropTypes from 'prop-types';

import { renderRoute } from './RouteHandler';

type DefaultProps = {};

type Props = {
  path: string,
  serverProps: ?{ [string]: any },
  meta: ?{ [string]: any },
  bundle: {
    name: string,
    load: Function,
  },
};

type State = { mod: ?Function };

class BundleLoader extends Component<DefaultProps, Props, State> {
  static defaultProps = {}
  static contextTypes = {
    router: PropTypes.any,
  }

  constructor() {
    super();
    this.state = { mod: null };
  }

  state: State;

  componentDidMount() {
    this.loadbundle();
  }

  loadbundle = async () => {
    const { bundle } = this.props;
    const routeBundle = await bundle.load();

    this.setState({ mod: routeBundle.default });
  }

  render() {
    const { mod } = this.state;
    if (!mod) { return null; }

    const { path, serverProps, meta } = this.props;
    const props = { component: mod, path, serverProps, meta };

    return React.createElement(renderRoute(props));
  }
}

export default BundleLoader;
