//  @flow
import 'babel-polyfill';
import React from 'react';
import { BrowserRouter } from 'react-router-dom';

import type { IConfig } from '../flow/IConfig';

const getClientProps = () => {
  try {
    const scriptsEl = document.getElementById('app-props');
    let props = scriptsEl
      ? scriptsEl.textContent : {};

    //  eslint-disable-next-line
    props = props.replace("<![CDATA[", "").replace("]]>", "");
    return JSON.parse(props);
  } catch (err) {
    throw new Error('Error parsing client props');
  }
};

const createClient = (config: IConfig) => {
  const serverProps = getClientProps();

  const { root: Root } = config;
  return (
    <BrowserRouter>
      <Root {...serverProps} />
    </BrowserRouter>
  );
};

export default createClient;
