import path from 'path';
import fs from 'fs';
import rimraf from 'rimraf';

const handleError = (err) => { throw new Error(err); };

const createOutputFolder = () => {
  const outputPath = path.resolve(process.cwd(), './public');

  return new Promise((resolve) => {
    if (!fs.existsSync(outputPath)) {
      fs.mkdir(outputPath, (err) => {
        if (err) handleError(err);
        resolve();
      });
    } else {
      rimraf(outputPath, (err) => {
        if (err) handleError(err);
        resolve(createOutputFolder(outputPath));
      });
    }
  });
};

export default createOutputFolder;
